freebsd-src/crypto/openssh/regress/dynamic-forward.sh
Ed Maste f374ba41f5 ssh: update to OpenSSH 9.2p1
Release notes are available at https://www.openssh.com/txt/release-9.2

OpenSSH 9.2 contains fixes for two security problems and a memory safety
problem.  The memory safety problem is not believed to be exploitable.
These fixes have already been committed to OpenSSH 9.1 in FreeBSD.

Some other notable items from the release notes:

 * ssh(1): add a new EnableEscapeCommandline ssh_config(5) option that
   controls whether the client-side ~C escape sequence that provides a
   command-line is available. Among other things, the ~C command-line
   could be used to add additional port-forwards at runtime.

 * sshd(8): add support for channel inactivity timeouts via a new
   sshd_config(5) ChannelTimeout directive. This allows channels that
   have not seen traffic in a configurable interval to be
   automatically closed. Different timeouts may be applied to session,
   X11, agent and TCP forwarding channels.

 * sshd(8): add a sshd_config UnusedConnectionTimeout option to
   terminate client connections that have no open channels for a
   length of time. This complements the ChannelTimeout option above.
    
 * sshd(8): add a -V (version) option to sshd like the ssh client has.

 * scp(1), sftp(1): add a -X option to both scp(1) and sftp(1) to
   allow control over some SFTP protocol parameters: the copy buffer
   length and the number of in-flight requests, both of which are used
   during upload/download. Previously these could be controlled in
   sftp(1) only. This makes them available in both SFTP protocol
   clients using the same option character sequence.
    
 * ssh-keyscan(1): allow scanning of complete CIDR address ranges,
   e.g.  "ssh-keyscan 192.168.0.0/24". If a CIDR range is passed, then
   it will be expanded to all possible addresses in the range
   including the all-0s and all-1s addresses. bz#976

 * ssh(1): support dynamic remote port forwarding in escape
   command-line's -R processing. bz#3499

MFC after:	1 week
Sponsored by:	The FreeBSD Foundation
2023-02-06 16:54:56 -05:00

111 lines
2.8 KiB
Bash

# $OpenBSD: dynamic-forward.sh,v 1.15 2023/01/06 08:50:33 dtucker Exp $
# Placed in the Public Domain.
tid="dynamic forwarding"
# This is a reasonable proxy for IPv6 support.
if ! config_defined HAVE_STRUCT_IN6_ADDR ; then
SKIP_IPV6=yes
fi
FWDPORT=`expr $PORT + 1`
make_tmpdir
CTL=${SSH_REGRESS_TMP}/ctl-sock
cp $OBJ/ssh_config $OBJ/ssh_config.orig
proxycmd="$OBJ/netcat -x 127.0.0.1:$FWDPORT -X"
trace "will use ProxyCommand $proxycmd"
start_ssh() {
direction="$1"
arg="$2"
n=0
error="1"
trace "start dynamic -$direction forwarding, fork to background"
(cat $OBJ/ssh_config.orig ; echo "$arg") > $OBJ/ssh_config
${REAL_SSH} -vvvnNfF $OBJ/ssh_config -E$TEST_SSH_LOGFILE \
-$direction $FWDPORT -oExitOnForwardFailure=yes \
-oControlMaster=yes -oControlPath=$CTL somehost
r=$?
test $r -eq 0 || fatal "failed to start dynamic forwarding $r"
if ! ${REAL_SSH} -qF$OBJ/ssh_config -O check \
-oControlPath=$CTL somehost >/dev/null 2>&1 ; then
fatal "forwarding ssh process unresponsive"
fi
}
stop_ssh() {
test -S $CTL || return
if ! ${REAL_SSH} -qF$OBJ/ssh_config -O exit \
-oControlPath=$CTL >/dev/null somehost >/dev/null ; then
fatal "forwarding ssh process did not respond to close"
fi
n=0
while [ "$n" -lt 20 ] ; do
test -S $CTL || break
sleep 1
n=`expr $n + 1`
done
if test -S $CTL ; then
fatal "forwarding ssh process did not exit"
fi
}
check_socks() {
direction=$1
expect_success=$2
for s in 4 5; do
for h in 127.0.0.1 localhost; do
trace "testing ssh socks version $s host $h (-$direction)"
${REAL_SSH} -q -F $OBJ/ssh_config \
-o "ProxyCommand ${proxycmd}${s} $h $PORT 2>/dev/null" \
somehost cat ${DATA} > ${COPY}
r=$?
if [ "x$expect_success" = "xY" ] ; then
if [ $r -ne 0 ] ; then
fail "ssh failed with exit status $r"
fi
test -f ${COPY} || fail "failed copy ${DATA}"
cmp ${DATA} ${COPY} || fail "corrupted copy of ${DATA}"
elif [ $r -eq 0 ] ; then
fail "ssh unexpectedly succeeded"
fi
done
done
}
start_sshd
trap "stop_ssh" EXIT
for d in D R; do
verbose "test -$d forwarding"
start_ssh $d
check_socks $d Y
stop_ssh
test "x$d" = "xR" || continue
# Test PermitRemoteOpen
verbose "PermitRemoteOpen=any"
start_ssh $d PermitRemoteOpen=any
check_socks $d Y
stop_ssh
verbose "PermitRemoteOpen=none"
start_ssh $d PermitRemoteOpen=none
check_socks $d N
stop_ssh
verbose "PermitRemoteOpen=explicit"
permit="127.0.0.1:$PORT [::1]:$PORT localhost:$PORT"
test -z "$SKIP_IPV6" || permit="127.0.0.1:$PORT localhost:$PORT"
start_ssh $d PermitRemoteOpen="$permit"
check_socks $d Y
stop_ssh
verbose "PermitRemoteOpen=disallowed"
permit="127.0.0.1:1 [::1]:1 localhost:1"
test -z "$SKIP_IPV6" || permit="127.0.0.1:1 localhost:1"
start_ssh $d PermitRemoteOpen="$permit"
check_socks $d N
stop_ssh
done